#include <ESP8266WiFi.h>

//Pins to which motors are connected (GPIO)
int M1forwardPin = 14;
int M1backwardPin = 12;
int M2forwardPin = 5;
int M2backwardPin = 4;
int sleepPin = 16;

//Pins to which the ultrasonic sensor is connected (GPIO)
const int trigPin = 13;
const int echoPin = 0;

//Define variable for distance calculation
long duration, distance;

void setup() {
  delay(random(500, 2000));
  pinMode(M1forwardPin, OUTPUT);
  pinMode(M1backwardPin, OUTPUT);
  pinMode(M2forwardPin, OUTPUT);
  pinMode(M2backwardPin, OUTPUT);
  pinMode(sleepPin, OUTPUT);

  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);

  digitalWrite(sleepPin, HIGH);
}

void loop() {
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);

  duration = pulseIn(echoPin, HIGH);
  distance = duration / 58.2;

  delay(10);

  if (distance > 15)
  {
    analogWrite(M1forwardPin, 128);
    analogWrite(M2forwardPin, 128);
    analogWrite(M1backwardPin, LOW);
    analogWrite(M2backwardPin, LOW);
    
  }
  
  if (distance < 14)
  {
    analogWrite(M1forwardPin, LOW);
    analogWrite(M2forwardPin, LOW);
    analogWrite(M1backwardPin, LOW);
    analogWrite(M2backwardPin, LOW);
    delay(200);
    analogWrite(M2backwardPin, 128);
    analogWrite(M1backwardPin, 128);
    analogWrite(M1forwardPin, LOW);
    analogWrite(M2forwardPin, LOW);
    delay(200);
    analogWrite(M1forwardPin, LOW);
    analogWrite(M2forwardPin, LOW);
    analogWrite(M1backwardPin, LOW);
    analogWrite(M2backwardPin, LOW);
    delay(100);
    analogWrite(M1forwardPin, 128);
    analogWrite(M2backwardPin, 128);
    analogWrite(M2forwardPin, LOW);
    analogWrite(M1backwardPin, LOW);
    delay(300);
  }
}
